From c505d24a8d00491f172a726c2cf59610a2f64654 Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Mon, 23 Apr 2012 13:39:04 -0700
Subject: [PATCH] * Completed the following six 'scriptlets':   Dogtag 10:
 Python 'initialization.py' Installation Scriptlet      
 (https://fedorahosted.org/pki/ticket/147)   Dogtag 10:
 Python 'instance_layout.py' Installation Scriptlet      
 (https://fedorahosted.org/pki/ticket/75)   Dogtag 10:
 Python 'webserver_layout.py' Installation Scriptlet      
 (https://fedorahosted.org/pki/ticket/140)   Dogtag 10:
 Python 'subsystem_layout.py' Installation Scriptlet      
 (https://fedorahosted.org/pki/ticket/141)   Dogtag 10:
 Python 'war_explosion.py' Installation Scriptlet      
 (https://fedorahosted.org/pki/ticket/76)   Dogtag 10:
 Python 'finalization.py' Installation Scriptlet      
 (https://fedorahosted.org/pki/ticket/148) * Created
 numerous PKI deployment helper utilities. * Augmented
 logging to provide indentation. * Generated logic for
 installation 'manifest'. * Tested logic using '--dry_run'
 option and '-p' prefix options. * Per initial review,
 removed numerous "constants" and consolidated   logic into
 "master" dictionary. * Corrected the following ticket:  
 Dogtag 10: Fix 'build_dogtag_pki' script to account for
 'pki-deploy' RPM      
 (https://fedorahosted.org/pki/ticket/138)       Resolves
 Bugzilla Bug #810047 - build_dogtag_pki fails with      
 requirements for pki-deploy      
 (https://bugzilla.redhat.com/show_bug.cgi?id=810047) *
 Created the following three 'scriptlets' as 'NOT YET
 IMPLEMENTED'   place-holders:   Dogtag 10: Python
 'security_databases.py' Installation Scriptlet      
 (https://fedorahosted.org/pki/ticket/136)   Dogtag 10:
 Python 'slot_assignment.py' Installation Scriptlet      
 (https://fedorahosted.org/pki/ticket/146)   Dogtag 10:
 Python 'configuration.py' Configuration Scriptlet      
 (https://fedorahosted.org/pki/ticket/137)

---
 base/deploy/CMakeLists.txt                       |  202 +++--
 base/deploy/config/pkideployment.cfg             |    8 +
 base/deploy/src/pkidestroy                       |  106 ++-
 base/deploy/src/pkispawn                         |  128 ++-
 base/deploy/src/scriptlets/configuration.py      |   52 +
 base/deploy/src/scriptlets/finalization.py       |  109 ++
 base/deploy/src/scriptlets/initialization.py     |   68 ++
 base/deploy/src/scriptlets/instance.py           |  105 --
 base/deploy/src/scriptlets/instance_layout.py    |   97 ++
 base/deploy/src/scriptlets/pkiconfig.py          |   64 +-
 base/deploy/src/scriptlets/pkihelper.py          | 1195 ++++++++++++++++++----
 base/deploy/src/scriptlets/pkilogging.py         |   30 +-
 base/deploy/src/scriptlets/pkimanifest.py        |   97 ++
 base/deploy/src/scriptlets/pkimessages.py        |  132 ++-
 base/deploy/src/scriptlets/pkiparser.py          |  362 +++++++
 base/deploy/src/scriptlets/pkiscriptlet.py       |    3 +-
 base/deploy/src/scriptlets/security_databases.py |   54 +-
 base/deploy/src/scriptlets/slot_assignment.py    |   52 +
 base/deploy/src/scriptlets/subsystem_layout.py   |  107 ++
 base/deploy/src/scriptlets/war_explosion.py      |   69 ++
 base/deploy/src/scriptlets/webserver_layout.py   |  119 +++
 scripts/build_dogtag_pki                         |    3 +-
 specs/pki-core.spec                              |   31 +-
 23 files changed, 2639 insertions(+), 554 deletions(-)
 create mode 100644 base/deploy/src/scriptlets/configuration.py
 create mode 100644 base/deploy/src/scriptlets/finalization.py
 create mode 100644 base/deploy/src/scriptlets/initialization.py
 delete mode 100644 base/deploy/src/scriptlets/instance.py
 create mode 100644 base/deploy/src/scriptlets/instance_layout.py
 create mode 100644 base/deploy/src/scriptlets/pkimanifest.py
 create mode 100644 base/deploy/src/scriptlets/pkiparser.py
 create mode 100644 base/deploy/src/scriptlets/slot_assignment.py
 create mode 100644 base/deploy/src/scriptlets/subsystem_layout.py
 create mode 100644 base/deploy/src/scriptlets/war_explosion.py
 create mode 100644 base/deploy/src/scriptlets/webserver_layout.py

diff --git a/base/deploy/CMakeLists.txt b/base/deploy/CMakeLists.txt
index 65c3eac..397c9a3 100644
--- a/base/deploy/CMakeLists.txt
+++ b/base/deploy/CMakeLists.txt
@@ -1,5 +1,26 @@
 project(deploy)
 
+set(PKI_SUBSYSTEMS
+    ca
+    kra
+    ocsp
+    ra
+    tks
+    tps
+)
+
+set(TOMCAT_SUBSYSTEMS
+    ca
+    kra
+    ocsp
+    tks
+)
+
+set(APACHE_SUBSYSTEMS
+    ra
+    tps
+)
+
 install(
     FILES
         src/pkispawn
@@ -34,13 +55,22 @@ execute_process(
 )
 install(
     FILES
-        src/scriptlets/instance.py
+        src/scriptlets/configuration.py
+        src/scriptlets/finalization.py
+        src/scriptlets/initialization.py
+        src/scriptlets/instance_layout.py
         src/scriptlets/pkiconfig.py
         src/scriptlets/pkihelper.py
-        src/scriptlets/pkimessages.py
         src/scriptlets/pkilogging.py
+        src/scriptlets/pkimanifest.py
+        src/scriptlets/pkimessages.py
+        src/scriptlets/pkiparser.py
         src/scriptlets/pkiscriptlet.py
         src/scriptlets/security_databases.py
+        src/scriptlets/slot_assignment.py
+        src/scriptlets/subsystem_layout.py
+        src/scriptlets/war_explosion.py
+        src/scriptlets/webserver_layout.py
     DESTINATION
         ${PYTHON_SITE_PACKAGES}/pki/deployment
     PERMISSIONS
@@ -67,60 +97,114 @@ install(
 #install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${VAR_INSTALL_DIR}/lock/pki)")
 #install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${VAR_INSTALL_DIR}/run/pki)")
 
-# install subsystem directories for pkispawn
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/kra)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ocsp)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ra)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/tks)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/tps)")
-
-# install subsystem directories for pkidestroy
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/ca)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/kra)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/ocsp)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/ra)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/tks)")
-install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/tps)")
-
-# generate and install symbolic links for pkispawn CA
-install(
-    CODE
-        "execute_process(
-            COMMAND
-                ${CMAKE_COMMAND} -E create_symlink
-                \"${PYTHON_SITE_PACKAGES}/pki/deployment/instance.py\"
-                \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0010_instance\")"
-)
-install(
-    CODE
-        "execute_process(
-            COMMAND
-                ${CMAKE_COMMAND} -E create_symlink
-                    \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
-                    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0020_security_databases\")"
-)
-
-# generate and install symbolic links for pkispawn KRA
-
-# generate and install symbolic links for pkispawn OCSP
-
-# generate and install symbolic links for pkispawn RA
-
-# generate and install symbolic links for pkispawn TKS
-
-# generate and install symbolic links for pkispawn TPS
-
-
-# generate and install symbolic links for pkidestroy CA
-
-# generate and install symbolic links for pkidestroy KRA
-
-# generate and install symbolic links for pkidestroy OCSP
-
-# generate and install symbolic links for pkidestroy RA
-
-# generate and install symbolic links for pkidestroy TKS
-
-# generate and install symbolic links for pkidestroy TPS
-
+# install subsystem directories for pkispawn and pkidestroy
+foreach(PKI_SUBSYSTEM ${PKI_SUBSYSTEMS})
+    install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${PKI_SUBSYSTEM})")
+    install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${PKI_SUBSYSTEM})")
+endforeach(PKI_SUBSYSTEM ${PKI_SUBSYSTEMS})
+
+# generate and install shared ordered 'scriptlet' symbolic links
+# for CA, KRA, OCSP, and TKS for pkispawn
+foreach(TOMCAT_SUBSYSTEM ${TOMCAT_SUBSYSTEMS})
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/initialization.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/000_initialization\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/instance_layout.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/010_instance_layout\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/webserver_layout.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/020_webserver_layout\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/subsystem_layout.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/030_subsystem_layout\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/war_explosion.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/040_war_explosion\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/050_security_databases\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/slot_assignment.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/060_slot_assignment\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/configuration.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/070_configuration\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/finalization.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/999_finalization\")"
+    )
+endforeach(TOMCAT_SUBSYSTEM ${TOMCAT_SUBSYSTEMS})
+
+# generate and install shared ordered 'scriptlet' symbolic links
+# for RA, and TPS for pkispawn
+
+# generate and install shared ordered 'scriptlet' symbolic links
+# for CA, KRA, OCSP, and TKS for pkidestroy
+foreach(TOMCAT_SUBSYSTEM ${TOMCAT_SUBSYSTEMS})
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/initialization.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/000_initialization\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/configuration.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/930_configuration\")"
+    )
+#   install(CODE "execute_process(COMMAND
+#       ${CMAKE_COMMAND} -E create_symlink
+#       \"${PYTHON_SITE_PACKAGES}/pki/deployment/slot_assignment.py\"
+#       \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/940_slot_assignment\")"
+#   )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/950_security_databases\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/war_explosion.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/960_war_explosion\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/subsystem_layout.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/970_subsystem_layout\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/webserver_layout.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/980_webserver_layout\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/instance_layout.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/990_instance_layout\")"
+    )
+    install(CODE "execute_process(COMMAND
+        ${CMAKE_COMMAND} -E create_symlink
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/finalization.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/999_finalization\")"
+    )
+endforeach(TOMCAT_SUBSYSTEM ${TOMCAT_SUBSYSTEMS})
+
+# generate and install shared ordered 'scriptlet' symbolic links
+# for RA, and TPS for pkidestroy
diff --git a/base/deploy/config/pkideployment.cfg b/base/deploy/config/pkideployment.cfg
index db9ce54..954fa93 100644
--- a/base/deploy/config/pkideployment.cfg
+++ b/base/deploy/config/pkideployment.cfg
@@ -1,5 +1,8 @@
 [Common]
+pki_source_root=/usr/share/pki
 pki_instance_root=/var/lib/pki
+pki_instance_configuration_root=/etc/pki
+pki_instance_log_root=/var/log/pki
 pki_instance_name=instance
 pki_user=pkiuser
 pki_group=pkiuser
@@ -10,19 +13,24 @@ pki_http_port=80
 pki_https_port=443
 [Tomcat]
 pki_web_server=Tomcat
+pki_tomcat_root=/usr/share/tomcat
 pki_http_port=8080
 pki_https_port=8443
 pki_ajp_port=8009
 pki_security_manager=true
 [CA]
 pki_subsystem=CA
+pki_war_name=ca.war
 [KRA]
 pki_subsystem=KRA
+pki_war_name=kra.war
 [OCSP]
 pki_subsystem=OCSP
+pki_war_name=ocsp.war
 [RA]
 pki_subsystem=RA
 [TKS]
 pki_subsystem=TKS
+pki_war_name=tks.war
 [TPS]
 pki_subsystem=TPS
diff --git a/base/deploy/src/pkidestroy b/base/deploy/src/pkidestroy
index a762e14..6d0afd2 100755
--- a/base/deploy/src/pkidestroy
+++ b/base/deploy/src/pkidestroy
@@ -23,15 +23,16 @@
 import sys
 if not hasattr(sys, "hexversion") or sys.hexversion < 0x020700f0:
     print "Python version %s.%s.%s is too old." % sys.version_info[:3]
-    print "Please upgrade to at least Python 2.7.0." 
+    print "Please upgrade to at least Python 2.7.0."
     sys.exit(1)
 try:
     import argparse
     import logging
     import os
     import pprint
+    from time import strftime as date
     from pki.deployment import pkiconfig as config
-    from pki.deployment import pkihelper
+    from pki.deployment import pkiparser as parse
     from pki.deployment import pkilogging
     from pki.deployment import pkimessages as log
 except ImportError:
@@ -52,23 +53,34 @@ def main(argv):
     if not os.geteuid() == 0:
         sys.exit("'%s' must be run as root!" % argv[0])
 
+    # Set the umask
+    os.umask(config.PKI_DEPLOYMENT_DEFAULT_UMASK)
+
+    # Generate a timestamp
+    config.pki_timestamp = date('%Y%m%d%H%M%S')
+
     # Initialize 'pretty print' for objects
     pp = pprint.PrettyPrinter(indent=4)
 
     # Read and process command-line arguments.
-    pkihelper.process_command_line_arguments(argv)
+    parse.process_command_line_arguments(argv)
 
     # Enable 'pkidestroy' logging.
-    config.pki_log_dir = config.pki_root_prefix +\
-                         config.PKIDESTROY_LOG_PATH
-    config.pki_log_name = config.PKIDESTROY_LOG_PREFIX +\
-                          config.pki_subsystem.lower() +\
-                          config.PKIDESTROY_LOG_SUFFIX
+    if not config.pki_dry_run_flag:
+        config.pki_log_dir = config.pki_root_prefix +\
+                             "/var/log"
+        config.pki_log_name = "pki" + "-" +\
+                              config.pki_subsystem.lower() +\
+                              "-" + "destroy" + "." +\
+                              config.pki_timestamp + "." + "log"
+    else:
+        config.pki_log_dir = "/dev"
+        config.pki_log_name = "null"
     rv = pkilogging.enable_pki_logger(config.pki_log_dir,
                                       config.pki_log_name,
                                       config.pki_log_level,
                                       config.pki_console_log_level,
-                                      config.PKIDESTROY_LOGGER)
+                                      "pkidestroy")
     if rv != OSError:
         config.pki_log = rv
     else:
@@ -76,17 +88,24 @@ def main(argv):
         sys.exit(1)
 
     # Read the specified PKI configuration file.
-    rv = pkihelper.read_pki_configuration_file()
+    rv = parse.read_pki_configuration_file()
     if rv != 0:
-        config.pki_log.error(PKI_UNABLE_TO_PARSE_1, rv)
+        config.pki_log.error(PKI_UNABLE_TO_PARSE_1, rv,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
         sys.exit(1)
     else:
-        config.pki_log.debug(log.PKI_DICTIONARY_COMMON)
-        config.pki_log.debug(pp.pformat(config.pki_common_dict))
-        config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER)
-        config.pki_log.debug(pp.pformat(config.pki_web_server_dict))
-        config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM)
-        config.pki_log.debug(pp.pformat(config.pki_subsystem_dict))
+        config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_common_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_web_server_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_subsystem_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Override PKI configuration file values with 'custom' command-line values.
     if not config.pki_instance_name is None:
@@ -101,51 +120,56 @@ def main(argv):
     if not config.pki_ajp_port is None:
         config.pki_web_server_dict['pki_ajp_port'] =\
             config.pki_ajp_port
-    config.pki_log.debug(log.PKI_DICTIONARY_COMMON)
-    config.pki_log.debug(pp.pformat(config.pki_common_dict))
-    config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER)
-    config.pki_log.debug(pp.pformat(config.pki_web_server_dict))
-    config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM)
-    config.pki_log.debug(pp.pformat(config.pki_subsystem_dict))
+    config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_common_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_web_server_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_subsystem_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Combine the various sectional dictionaries into a PKI master dictionary
-    pkihelper.create_pki_master_dictionary()
-    config.pki_log.debug(log.PKI_DICTIONARY_MASTER)
-    config.pki_log.debug(pp.pformat(config.pki_master_dict))
+    parse.compose_pki_master_dictionary()
+    config.pki_master_dict['pki_destroy_log'] = config.pki_log_dir + "/" +\
+                                                config.pki_log_name
+    config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_master_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Remove the specified PKI subsystem.
-    pki_scriptlets_path = config.pki_root_prefix +\
-                          config.PKIDESTROY_PATH +\
+    pki_scriptlets_path = "/usr/share/pki/deployment/destroy" +\
                           "/" + config.pki_subsystem.lower()
     if not os.path.exists(pki_scriptlets_path) or\
        not os.path.isdir(pki_scriptlets_path):
         config.pki_log.error(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
-                             pki_scriptlets_path)
+                             pki_scriptlets_path,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
         sys.exit(1)
     pki_subsystem_scriptlets = os.listdir(pki_scriptlets_path)
     pki_subsystem_scriptlets.sort()
 
     # Process the various "scriptlets" for the specified PKI subsystem.
     rv = 0
-    config.pki_log.info(log.PKIDESTROY_BEGIN_MESSAGE_2,
-                        config.pki_subsystem,
-                        config.pki_master_dict['pki_instance_name'])
     for pki_scriptlet in pki_subsystem_scriptlets:
-        scriptlet = __import__(config.PKI_DEPLOYMENT_SCRIPTLETS_MODULE +\
-                               '.' + pki_scriptlet[5:],
-                               fromlist = [pki_scriptlet[5:]])
+        scriptlet = __import__("pki.deployment" +\
+                               "." + pki_scriptlet[4:],
+                               fromlist = [pki_scriptlet[4:]])
         instance = scriptlet.PkiScriptlet()
         rv = instance.destroy()
         if rv != 0:
             sys.exit(1)
-    config.pki_log.info(log.PKIDESTROY_END_MESSAGE_2,
-                        config.pki_subsystem,
-                        config.pki_master_dict['pki_instance_name'])
-    config.pki_log.debug(log.PKI_DICTIONARY_MASTER)
-    config.pki_log.debug(pp.pformat(config.pki_master_dict))
+    config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_master_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
 
 # PKI Deployment Entry Point
 if __name__ == "__main__":
     main(sys.argv)
-
